"use strict";
/* IMPORT */
Object.defineProperty(exports, "__esModule", { value: true });
const consts_1 = require("../consts");
/* RETRYIFY QUEUE */
const RetryfyQueue = {
    queue: new Set(),
    schedule: (id, limit = consts_1.LIMIT_FILES_DESCRIPTORS) => {
        const add = () => RetryfyQueue.queue.add(id), remove = () => RetryfyQueue.queue.delete(id);
        return new Promise(resolve => {
            const check = () => {
                if (RetryfyQueue.queue.size >= limit)
                    return setTimeout(check, 150);
                add();
                resolve(remove);
            };
            check();
        });
    }
};
/* EXPORT */
exports.default = RetryfyQueue;
